import { createMuiTheme, makeStyles, ThemeProvider } from "@material-ui/core/styles";
import React from "react";
import Styles from "./styles";
var useStyles = makeStyles({
  container: {
    fontFamily: '"Inter", sans-serif',
    color: "var(--font-color-text)"
  }
});
var theme = createMuiTheme({
  typography: {
    fontFamily: '"Inter", "Roboto", sans-serif'
  },
  overrides: {
    MuiButton: {
      root: {
        // background: "linear-gradient(to right bottom, rgb(249, 37, 255), rgb(0, 72, 186))",
        textTransform: "none"
      },
      label: {
        color: "var(--font-color-text)"
      }
    },
    MuiCollapse: {
      root: {
        color: "aqua",
        background: "var(--header-background-color)"
      }
    },
    MuiSvgIcon: {
      root: {
        color: "var(--font-color-text)"
      }
    }
  }
});
export var Theme = function Theme(_ref) {
  var children = _ref.children;
  var classes = useStyles();
  return React.createElement(Styles, null, React.createElement(ThemeProvider, {
    theme: theme
  }, React.createElement("div", {
    className: classes.container
  }, children)));
};
export default Theme;